#!/usr/bin/perl
#
#  extract Netscape Navigator v 3.04 or 
#          Netscape Communicator v 4.04 for BSDI 1.1
#  disk cache data
#	by george@yk.rim.or.jp
#
#  Netscape Communicator 4.04 for BSDI 1.1 $B$N%G%#%9%/%-%c%C%7%e$+$i(B
#  $B%G!<%?$r<h$j=P$9(B perl $B%9%/%j%W%H(B nesuke.pl
#
#------------------------------------------------------------
#  $B35MW(B
#
#Netscape Navigator 3.X / 4.X $B$N%G%#%9%/%-%c%C%7%e$O!"(BOS(FreeBSD$B$J$I(B)$B$,(B
#$B;}$C$F$$$k%G!<%?%Y!<%95!G=$rMxMQ$7$F!"(BURL$B$H$=$NFbMF$rJ]B8$7$?%U%!%$%k(B
#$BL>$J$I$r(B~/.netscape/cache/index.db$B$K5-O?$7$F$$$k!#(B
#
#$B$3$N%W%m%0%i%`$G$O!"(Bperl$B$N;}$D(Bdbmopen$B4X?t$rMxMQ$7$F%-%c%C%7%e%G!<%?%Y!<(B
#$B%9$N%$%s%G%C%/%9(B(index.db)$B$r<h$j=P$7!"(Bperl$B$NO"A[G[Ns$KBP1~$E$1$i$l$?%-%c%C(B
#$B%7%e%G!<%?%Y!<%9$r=g<!%9%-%c%s$9$k$3$H$K$h$j!"(BURL$B$H%-%c%C%7%e%U%!(B
#$B%$%kL>$NBP1~$r<h$j=P$7$F$$$k!#(B
#
#------------------------------------------------------------
# index.db key value structure
#
#  struct url_key_data {
#    long total_length;			/* 0: */
#    long url_length;			/* 1: */
#    char url[];			/* 2: */
#    long cookie_length;		/* 3: */
#    char cookie_data[cookie_length];	/* 4: */
#  }
#

#------------------------------------------------------------
#  define url key data offsets
#
$KEY_TOTAL_LENGTH = 0;
$KEY_URL_LENGTH = 1;
$KEY_URL = 2;
$KEY_CGI_LENGTH = 3;
$KEY_CGI = 4;

sub decode_url_key {
    local ($key) = @_;
    local ($templ, @KEY, @KEY3);
    $templ = "VV";
    @KEY = unpack($templ, $key);
    $templ = "VVA" . $KEY[$#KEY] . "V";
    @KEY2 = unpack($templ, $key);
    $templ = "VVA" . $KEY[$#KEY] . "VH" . $KEY2[$#KEY2]*2;
    @KEY3 = unpack($templ, $key);
    return @KEY3;
}

# FIXME : not tested.
sub encode_url_key {
    local ($url) = @_;
    local ($length, $buf, $templ);
    $templ = "VVA" . $#url . "V";
    $buf = pack($templ, 0, $#url, $url, 0);
    $buf = pack($templ, $#buf, $#url, $url, 0);
    return $buf;
}
#------------------------------------------------------------
# index.db cache database value structure
#
# struct url_value {
#   long total_length;		/* 0:size of the entire structure */
#   long version;		/* 1:version of the structure format : Navigator v 3 = 3, Communicator = 4 , Free Software version Communicator = 5 */
#   time_t last_modified;	/* 2: set to 0 if can't get modified time. */
#   time_t last_accessed;	/* 3: */
#   time_t expires;		/* 4: thanks to Ando Ryota */
#   long content_length;	/* 5: content length */
#   char is_netsite;		/* 6: Bool is_netsite ? ; always 0 or 1 */
#   time_t lock_date;		/* 7: lock_date ? : always 0 */ 
#   long cache_filename_length;	/* 8: */
#   char cache_filename[cache_filename_length]; /* 9: */
#   long security_on;		/* 10: security? : always 0 */
#   long unknown;		/* 11: always 1 */
#   char unknown[17];		/* 12: long val[3]; long len; char str[] ?*/
#   long method;		/* 13: method? : always 0 */
#   long application_type_length;	/* 14: */
#   char application_type[length];	/* 15: */
#   long content_type_length;	/* 16: */
#   char content_type[content_type_length];	/* 17: */
#   long unknown;		/* 18:always 0 */
#   long content_encoding_type_length;	/* 19: */
#   long content_encoding_type[content_encoding_type_length];	/* 20 */
#   char incomplete_file;	/* 21: bool incomplete_file? : always 0 or 1 */
#   long total_content_length;	/* 22: total_content_length */
#   char unknown[];		/* 23:page_services_url ? : length is not constant */
#
#

#------------------------------------------------------------
#  define url value offsets
#
$VAL_MODTIME = 2;
$VAL_VISITTIME = 3;
$VAL_CACHE_FILENAME = 9;
$VAL_CACHE_FILE_LENGTH = 8;
$VAL_CONTENT_TYPE = 15;
$VAL_CACHE_FILE_LENGTH2 = 22;

sub decode_url_value {
    local($value) = @_;
    local(@VAL, @VAL2, @VAL3, @VAL4, $templ);

    $templ = "VVVVVVH2VV"; 
    @VAL = unpack($templ, $value);
    $templ = $templ . "A" . $VAL[$#VAL] . "V V H34 V V"; # H34 = VVV VA ?
    @VAL2 = unpack($templ, $value);
    $templ = $templ . "A" . $VAL2[$#VAL2] . "V";
    @VAL3 = unpack($templ, $value);
    $templ = $templ . "A" . $VAL3[$#VAL3] . "VV";
    @VAL4 = unpack($templ, $value);
    $templ = $templ . "A" . $VAL4[$#VAL4] . "H2 V H*";
    @VAL5 = unpack($templ, $value);
    return @VAL5;
}

# FIXME : not supported
sub encode_url_value {
    local($modtime, $visittime, $content_length);
}

#------------------------------------------------------------
# print help message and exit
#
sub usage {
print <<'END_OF_HELP';
nesuke.pl --- Display or extract Netscape's disk cache data.
  usage)nesuke.pl options [suboptions...] [url regex pattern]
    options:
      t:print list of file
      v:verbose mode
      x:extract files with sub directory
      e:extract files into current directory

    sub options:
      --help   :print this
      --dir dir:set cache dir [default ~/.netscape/cache/]
      --debug  :set debug mode
      --type t :set extract file type
        t means image , gif , jpeg , text , plain or html

END_OF_HELP

#      --long   :set extract file name as long file name [default]
#      --short  :set extract file name as short file name

    exit 1;
}
#------------------------------------------------------------
# url_to_filename
#
#
sub url_to_file {
    local ($from) = @_;
    $from =~ s/[^\w\.+-]/_/g;
    return $from;
}

sub url_to_file_with_dir {
    local ($from) = @_;
    $from =~ s/[^\w\.\/+-]/_/g;
    return $from;
}

#------------------------------------------------------------
# analyze command line options
#
#
# at first, command option
if ( $#ARGV < 0 ) {
    &usage();
}
for ( $i=0 ; $i < length($ARGV[0]) ; $i++ ) {
    $ch = substr($ARGV[0], $i, 1);
    if ( $ch eq "t" ) {
	$table_mode = 1;
    } elsif ( $ch eq "v" ) {
	$verbose_mode = 1;
    } elsif ( $ch eq "x" ) {
	$extract_dir_mode = 1;
    } elsif ( $ch eq "e" ) {
	$extract_cwd_mode = 1;
    } elsif ( $ch eq "-" ) {
    } else {
	print " illegal option $ch\n";
	&usage();
    }
}
shift(@ARGV);
# at second, another options
while (0 <= $#ARGV) {
    $i = shift(@ARGV);
    # print "$#ARGV, $i\n";
    if ( $i eq "--debug" ) {
	$debug_mode = 1;
    } elsif ( $i eq "--dump" ) {
	$dump_mode = 1;
    } elsif ( $i eq "--dir" ) {
	$cache_base_dir = shift(@ARGV);
    } elsif ( $i eq "--type" ) {
	$type_mode = shift(@ARGV);
    } elsif ( $i eq "--help" ) {
	&usage();
    } elsif ( substr($i, 0, 2) eq "--" ) {
	print "  illegal option $i\n";
	&usage();
    } else {
	push (@ARGVPAT, $i);
	# print 'ARGVPAT = ' . "@ARGVPAT\n";
    }
}

#------------------------------------------------------------
# set default settings
#
if (!defined($home_dir)) {
    $home_dir = $ENV{'HOME'} . "/";
}
if (!defined($cache_base_dir)) {
    $cache_base_dir = "$home_dir" . ".netscape/cache/";
}
#------------------------------------------------------------
# main
#

$cache_index_file = $cache_base_dir . "index";
dbmopen(%DATA, $cache_index_file, 0666) || die "can not open $cache_index_file. abort.\n";
print "reading $cache_index_file...\n";

while (($key, $value)=each %DATA) {
    if ($dump_mode) {
	print $key, ' = ', $value, "\n";
	print unpack('H*', $key), ' = ', unpack('H*', $value), "\n";
    }

    if ($dump_mode) {
	$keytype = unpack('a4', $key);
	if ($keytype eq "INT_") {
	    $value1 = unpack('A*', $value);
	    print "key:$key = value:$value1 \n";
	}
    }

    ($keytype) = unpack('V', $key);
    if ($keytype < 100) {
	@KEY = &decode_url_key($key);
	# print "key=@KEY\n";
	if ($debug_mode == 1) {
	    $i = 0;
	    foreach $a (@KEY) {
		print "key : $i : " . $a . "\n";
		$i++;
	    }
	}

	@VAL = &decode_url_value($value);
	# print "value=@VAL\n";
	if ($debug_mode == 1) {
	    $i = 0;
	    foreach $a (@VAL) {
		print "value : $i : " . $a . "\n";
		$i++;
	    }
	}

	$url = $KEY[$KEY_URL];
	if ( $] < 5.0 ) {
	    $1 = "";
	    $2 = "";
	}
	$file = $url;
	$file =~ s/^.*:\/\///i; # remove http:// or ftp:// , etc...
	$file =~ /(.*)\/([^\/]*)$/;
	$filedstshortdir = &url_to_file_with_dir($1);
	$filedstshort = $2;
	if ( length($filedstshort) == 0 ) {
	    $filedstshort = "index.html";
	}
	$filedstshort = &url_to_file($filedstshort);
	$filedstlong = &url_to_file($file);
	$filesrc = $VAL[$VAL_CACHE_FILENAME];
	$len = $VAL[$VAL_CACHE_FILE_LENGTH];
	$type = $VAL[$VAL_CONTENT_TYPE];
	
	# $B%U%!%$%k%?%$%WH=JL(B
	if ( $type_mode ) {
	    if (! ($type =~ /$type_mode/i) ) {
		# $B%U%!%$%k%?%$%W$,0c$&$N$G%9%-%C%W!#(B
		next;
	    }
	}

	# $B%U%!%$%kL>H=JL(B
	if ( $#ARGVPAT > -1 ) {
	    $ff_hit = 0;
	    foreach $f (@ARGVPAT) {
		if ( $url =~ /$f/ ) {
		    $ff_hit = 1;
		}
	    }
	    if ( $ff_hit == 0 ) {
		# $B%U%!%$%kL>$,0[$J$k$N$G%9%-%C%W(B
		next;
	    }
	}

	# $BI=<(=hM}(B
	if ( $table_mode ) {
	    if ( $verbose_mode ) {
		printf("  %6d %s %s %s %s\n", $len, $url, $filedstlong, $filedstshortdir, $filedstshort);
	    } else {
		printf("%s\n", $url);
	    }
	}

	# $B%U%!%$%k$K%3%T!<$9$k=hM}(B
	# WWW$B>e$N%G%#%l%/%H%j9=@.$r:F8=$9$k%b!<%I(B
	if ( $extract_dir_mode ) {
	    if ( ! (-d $filedstshortdir) ) {
		$cmd = "mkdir -p " . $filedstshortdir;
		system $cmd;
	        print $cmd . "\n" if ( $debug_mode );
	    }
	    $cmd = "cp -p " . $cache_base_dir . $filesrc . " " . $filedstshortdir . "/" . $filedstshort;
	    system $cmd;
	    print $cmd . "\n" if ( $debug_mode );
	    if ( $verbose_mode ) {
		print $filedstshortdir . "/" . $filedstshort . "\n";
	    }
	}

	# $B%U%!%$%k$K%3%T!<$9$k=hM}(B
	# $B%G%#%l%/%H%j$r<($9J8;z(B / $B$r(B _ $B$KJQ49$7$F(B
        # $B0l$D$ND9$$%U%!%$%kL>$K$9$k%b!<%I(B
	if ( $extract_cwd_mode ) {
	    $cmd = "cp -p " . $cache_base_dir . $filesrc . " " . $filedstlong;
	    system $cmd;
	    print $cmd . "\n" if ( $debug_mode );
	    if ( $verbose_mode ) {
		print $filedstlong . "\n";
	    }
	}

    }
    print "----------------------------------------\n" if ($debug_mode);
}
dbmclose(DATA);

