#!/usr/local/bin/perl
#
# decodeurl.pl --- decode URL encoded form
#  for perl5 only
#
sub decodeURL {
  local($buf) = @_;
  $buf =~ tr/+/ /;
  $buf =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("c",hex($1))/ge;
  return $buf;
}

sub deleteCRLF {
  local($buf) = @_;
  $buf =~ s/=[\015\012]//gm;
  return $buf;
}
#
# main 
#

$buf = "";

while (<STDIN>) {
  $buf = $buf . $_;
}
$buf1 = &deleteCRLF($buf);
$buf2 = &decodeURL($buf1);
print $buf1;
print $buf2;

#
#  end of decodeurl.pl
#
